###############################################################################
## This file is part of the Wolfpack module system
## Copyright (C) 1998-2001  Tothwolf <tothwolf@concentric.net>
## and is distributed according to the GNU general public license.
## For full details, read the top of wolfpack.tcl or the file called
## COPYING that was distributed with this code.
##
## $Id: logman.tcl,v 1.3 2001/06/01 05:38:49 tothwolf Exp $
##

# name: logman
# version: 0.0.0.2
# config: logman.conf
# description:
# requires: this_module_needs_to_be_converted

namespace eval logman {

  # Set namespace variables
  set NamespaceParent [namespace parent]
  set NamespaceCurrent [namespace current]

if {0} then {

#[time]

set conf(logsdir) "/home/eggdrop/logs"
set conf(dbfile) "logman.db"


set time_seconds [clock seconds]
set time_today [clock format $time_seconds -format "%d%b%y"]
set time_yesterday [clock format [expr $time_seconds - 86400] -format "%d%b%y"]


foreach i [glob [file join $conf(logsdir) *]] {
  if {[file isfile $i]} then {
    if {[regexp ".*\.log\.${time_yesterday}" $i]} then {
#isfile, yesterday
    }
  } elseif {[file isdir $i]} then {
    foreach j [glob [file join $conf(logsdir) $i *]] {
      if {[file isfile $j]} then {
        if {[regexp ".*\.log\.${time_yesterday}" $i]} then {
#isfile, yesterday
        }
      }
    }
  }
}

  } elseif {[file isfile $i]} then {
  } else {
  }

} ;# if 0

  # Configuration data defaults
  array set configDataDefaults {
    mailto ""
  }

  # Configuration data descriptions
  array set configDataDesc {
    mailto "\[address\] email address to email logs / status info to"
  }

} ;# namespace logman

return
