###############################################################################
## This file is part of the Wolfpack module system
## Copyright (C) 1998-2001  Tothwolf <tothwolf@concentric.net>
## and is distributed according to the GNU general public license.
## For full details, read the top of wolfpack.tcl or the file called
## COPYING that was distributed with this code.
##
## $Id: huntcmds.tcl,v 1.2 2001/06/02 03:15:07 tothwolf Exp $
##

# name: wrpg-huntcmds
# version: 1.0.0.0
# description:
# requires: huntData commandChar

namespace eval wrpg-huntcmds {

  # adds an animal to the hunt list; pub
  proc pub:addhunt {nick uhost hand chan arg} {
    return [addhunt pub putnot $nick putnot $nick $nick $uhost $hand $chan $arg]
  }

  # adds an animal to the hunt list; msg
  proc msg:addhunt {nick uhost hand arg} {
    return [addhunt msg putnot $nick putnot $nick $nick $uhost $hand "" $arg]
  }

  # adds an animal to the hunt list; dcc
  proc dcc:addhunt {hand idx arg} {
    return [addhunt dcc putdcc $idx putdcc $idx "" "" $hand "" $arg]
  }

  # adds an animal to the hunt list
  proc addhunt {type resp1 dest1 resp2 dest2 nick uhost hand chan arg} {
#    variable huntdata
#    variable huntdata_changed
#    variable NamespaceCurrent
#
#    if {[authCheck $type addhunt $nick $uhost $hand $chan]} then {
#      set arg [split [string trimright $arg]]
#      set count [llength [split [lindex $arg end] :]]
#      if {$count > 5} then {
#        set animal [lrange $arg 0 [expr [llength $arg] - 3]]
#        set options [lindex $arg [expr [llength $arg] - 2]]
#        set diceopt [lindex $arg end]
#      } else {
#        set animal [lrange $arg 0 [expr [llength $arg] - 2]]
#        set options [lindex $arg end]
#      }
#      scan $options "%\[^:\]:%\[^:\]:%\[^:\]:%\[^:\]:%\[^:\]:" group hits food hunt sound
#      if {(![string length $animal]) || (![info exists group]) || (![info exists hits]) || (![info exists food]) || (![info exists hunt]) || (![info exists sound])} then {
#        put $resp2 $dest2 "Usage: [commandChar $type]addhunt <animal> <group:hits:food:hunt:sound> \[diceopt\]"
#      } else {
#        if {[info exists diceopt]} then {
#          regsub -all -- : $diceopt " " diceopt
#          regsub -all -- - $diceopt " " diceopt
#        } else {
#          set diceopt ""
#        }
#        set animal [arrayFindElementName ${NamespaceCurrent}::huntdata $animal]
#        if {![string length $animal]} then {
#          if {![isNumber [lindex $animal end]]} then {
#            if {[isNumber $group]} then {
#              if {[isNumber $hits]} then {
#                if {[isNumber $food]} then {
#                  if {[isNumber $hunt]} then {
#                    if {[isNumber $sound]} then {
#                      set huntdata($animal) [list $group $hits $food $hunt $sound $diceopt]
#                      set huntdata_changed 1
#                      put $resp1 $dest1 "The [join $animal] has been added to the hunt list."
#                    } else {
#                      put $resp2 $dest2 "Invalid number to set sound to."
#                    }
#                  } else {
#                    put $resp2 $dest2 "Invalid humber to set hunt to."
#                  }
#                } else {
#                  put $resp2 $dest2 "Invalid number to set food to."
#                }
#              } else {
#                put $resp2 $dest2 "Invalid number to set hits to."
#              }
#            } else {
#              put $resp2 $dest2 "Invalid number to set group to."
#            }
#          } else {
#            put $resp2 $dest2 "Animal's name may not end with a number"
#          }
#        } else {
#          put $resp2 $dest2 "I already know what [grammar_check2 0 [join $animal]] is."
#        }
#      }
#      return 1
#    }
#    return 0
  }

  # removes an animal to the hunt list; pub
  proc pub:delhunt {nick uhost hand chan arg} {
    return [delhunt pub putnot $nick putnot $nick $nick $uhost $hand $chan $arg]
  }

  # removes an animal to the hunt list; msg
  proc msg:delhunt {nick uhost hand arg} {
    return [delhunt msg putnot $nick putnot $nick $nick $uhost $hand "" $arg]
  }

  # removes an animal to the hunt list; dcc
  proc dcc:delhunt {hand idx arg} {
    return [delhunt dcc putdcc $idx putdcc $idx "" "" $hand "" $arg]
  }

  # removes an animal to the hunt list
  proc delhunt {type resp1 dest1 resp2 dest2 nick uhost hand chan arg} {
#    variable huntdata
#    variable fooddata
#    variable huntdata_changed
#    variable fooddata_changed
#    variable NamespaceCurrent
#
#    if {[authCheck $type delhunt $nick $uhost $hand $chan]} then {
#      set arg [split [string trimright $arg]]
#      if {![string length $arg]} then {
#        put $resp2 $dest2 "Usage: [commandChar $type]delhunt <animal>"
#      } else {
#        set animal [arrayFindElementName ${NamespaceCurrent}::huntdata $arg]
#        if {[string length $animal]} then {
#          if {[info exists fooddata($animal)]} then {
#            unset fooddata($animal)
#            set fooddata_changed 1
#            unset huntdata($animal)
#            set huntdata_changed 1
#            put $resp1 $dest1 "The [join $animal] has been removed from the hunt and food lists."
#          } else {
#            unset huntdata($animal)
#            set huntdata_changed 1
#            put $resp1 $dest1 "The [join $animal] has been removed from the hunt list."
#          }
#        } else {
#          put $resp2 $dest2 "I don't know what [grammar_check2 0 [join $animal]] is."
#        }
#      }
#      return 1
#    }
#    return 0
  }

  # changes an animal to the hunt list; pub
  proc pub:chhunt {nick uhost hand chan arg} {
    return [chhunt pub putnot $nick putnot $nick $nick $uhost $hand $chan $arg]
  }

  # changes an animal to the hunt list; msg
  proc msg:chhunt {nick uhost hand arg} {
    return [chhunt msg putnot $nick putnot $nick $nick $uhost $hand "" $arg]
  }

  # changes an animal to the hunt list; dcc
  proc dcc:chhunt {hand idx arg} {
    return [chhunt dcc putdcc $idx putdcc $idx "" "" $hand "" $arg]
  }

  # changes an animal to the hunt list
  proc chhunt {type resp1 dest1 resp2 dest2 nick uhost hand chan arg} {
#    variable huntdata
#    variable fooddata
#    variable huntdata_changed
#    variable fooddata_changed
#    variable NamespaceCurrent
#
#    if {[authCheck $type chhunt $nick $uhost $hand $chan]} then {
#      set arg [split [string trimright $arg]]
#      set count [llength [split [lindex $arg end] :]]
#      if {$count > 5} then {
#        set animal [arrayFindElementName ${NamespaceCurrent}::huntdata [lrange $arg 0 [expr [llength $arg] - 3]]]
#        set options [lindex $arg [expr [llength $arg] - 2]]
#        set diceopt [lindex $arg end]
#        set tmp [split $options :]
#        scan $options "%\[^:\]:%\[^:\]:%\[^:\]:%\[^:\]:%\[^:\]:" group hits food hunt sound
#      } elseif {$count > 2} then {
#        set animal [arrayFindElementName ${NamespaceCurrent}::huntdata [lrange $arg 0 [expr [llength $arg] - 2]]]
#        set options [lindex $arg end]
#        set tmp [split $options :]
#        scan $options "%\[^:\]:%\[^:\]:%\[^:\]:%\[^:\]:%\[^:\]:" group hits food hunt sound
#      } else {
#        set animal [arrayFindElementName ${NamespaceCurrent}::huntdata [string trimright [lindex [split $arg :] 0]]]
#        set animal2 [string trimleft [lindex [split $arg :] 1]]
#      }
#      if {![string length $arg]} then {
#        put $resp2 $dest2 "Usage: [commandChar $type]chhunt <animal> <group:hits:food:hunt:sound> \[diceopt\] | <oldanimal>:<newanimal>"
#      } elseif {[string length $animal]} then {
#        if {[info exists animal2]} then {
#          if {![string compare $animal $animal2]} then {
#            if {![isNumber [lindex $animal end]]} then {
#              if {[info exists fooddata($animal)]} then {
#                set fooddata($animal2) $fooddata($animal)
#                unset fooddata($animal)
#                set fooddata_changed 1
#              }
#              set huntdata($animal2) $huntdata($animal)
#              unset huntdata($animal)
#              set huntdata_changed 1
#              put $resp1 $dest1 "Renamed [join $animal] to [join $animal2]."
#            } else {
#              put $resp2 $dest2 "Animal name may not end with a number"
#            }
#          } else {
#            put $resp2 $dest2 "You must specify a different name to rename an animal to."
#          }
#        } else {
#          if {[info exists diceopt]} then {
#            regsub -all -- : $diceopt " " diceopt
#            regsub -all -- - $diceopt " " diceopt
#          } else {
#            set diceopt [lindex $huntdata($animal) 5]
#          }
#          if {[isNumber $group]} then {
#            if {[isNumber $hits]} then {
#              if {[isNumber $food]} then {
#                if {[isNumber $hunt]} then {
#                  if {[isNumber $sound]} then {
#                    #FIXME: if provided, show dice options when adding
#                    if {([lrange $huntdata($animal) 0 4] != $tmp) || ([lindex $huntdata($animal) 5] != $diceopt)} then {
#                      set huntdata($animal) [list $group $hits $food $hunt $sound $diceopt]
#                      set huntdata_changed 1
#                      put $resp1 $dest1 "The [join $animal] has been set to: $group:$hits:$food:$hunt:$sound"
#                    } else {
#                      put $resp2 $dest2 "The [join $animal] was already set to: $group:$hits:$food:$hunt:$sound"
#                    }
#                  } else {
#                    put $resp2 $dest2 "Invalid number to set sound to."
#                  }
#                } else {
#                  put $resp2 $dest2 "Invalid humber to set hunt to."
#                }
#              } else {
#                put $resp2 $dest2 "Invalid number to set food to."
#              }
#            } else {
#              put $resp2 $dest2 "Invalid number to set hits to."
#            }
#          } else {
#            put $resp2 $dest2 "Invalid number to set group to."
#          }
#        }
#      } else {
#        put $resp2 $dest2 "I don't know what [grammar_check2 0 [join $animal]] is."
#      }
#      return 1
#    }
#    return 0
  }

  # lists the hunt list; pub
  proc pub:listhunt {nick uhost hand chan arg} {
    return [listhunt pub putnot $nick putnot $nick $nick $uhost $hand $chan $arg]
  }

  # lists the hunt list; msg
  proc msg:listhunt {nick uhost hand arg} {
    return [listhunt msg putnot $nick putnot $nick $nick $uhost $hand "" $arg]
  }

  # lists the hunt list; dcc
  proc dcc:listhunt {hand idx arg} {
    return [listhunt dcc putdcc $idx putdcc $idx "" "" $hand "" $arg]
  }

  # lists the hunt list
  proc listhunt {type resp1 dest1 resp2 dest2 nick uhost hand chan arg} {
#    variable huntdata
#    variable NamespaceCurrent
#
#    if {[authCheck $type listhunt $nick $uhost $hand $chan]} then {
#      set what [split [string trimright $arg]]
#      set count 0
#      if {![string length $what]} then {
#        foreach i [lsort [array names huntdata]] {
#          lappend list "[join $i] \[[lindex $huntdata($i) 0]:[lindex $huntdata($i) 1]:[lindex $huntdata($i) 2]:[lindex $huntdata($i) 3]:[lindex $huntdata($i) 4]\],"
#          incr count
#        }
#        if {[info exists list]} then {
#          formatLists $resp1 $dest1 [string trimright [join $list] ,] 160 , , " " "The following animals are on the hunt list ($count): " "(cont): "
#        } else {
#          put $resp2 $dest2 "The hunt list is empty :("
#        }
#      } elseif {[isNumber $what]} then {
#        foreach i [lsort [array names huntdata]] {
#          if {![string compare $what [lindex $huntdata($i) 0]]} then {
#            lappend list "[join $i] \[[lindex $huntdata($i) 0]:[lindex $huntdata($i) 1]:[lindex $huntdata($i) 2]:[lindex $huntdata($i) 3]:[lindex $huntdata($i) 4]\],"
#            incr count
#          }
#        }
#        if {[info exists list]} then {
#          formatLists $resp1 $dest1 [string trimright [join $list] ,] 160 , , " " "The following animals are on the hunt list that are in group $what ($count): " "(cont): "
#        } else {
#          put $resp2 $dest2 "No animals in the hunt list for group $what"
#        }
#      } else {
#        set animal [arrayFindElementName ${NamespaceCurrent}::huntdata $what]
#        if {[string length $animal]} then {
#          put $resp1 $dest1 "Info for [join $animal]: \[[lindex $huntdata($animal) 0]:[lindex $huntdata($animal) 1]:[lindex $huntdata($animal) 2]:[lindex $huntdata($animal) 3]:[lindex $huntdata($animal) 4]\]"
#        } else {
#          put $resp2 $dest2 "I don't know what [grammar_check2 0 $what] is."
#        }
#      }
#      return 1
#    }
#    return 0
  }

  ##
  ## Init module specific things at load time
  ##
  ## Args:    action {load|unload}
  ## Returns: nothing
  ##
  proc InitTable {action} {
    variable NamespaceCurrent

    switch -exact -- $action {
      load {
        if {![info exists NamespaceCurrent]} then {
          set NamespaceCurrent [namespace current]
        }
      }
    }
    return
  }

  ##
  ## Bind procs to commands and events
  ##
  ## Args:    action {bind|unbind}, what {type|*}, args {...}
  ## Returns: nothing
  ##
  proc BindTable {action what args} {
    variable NamespaceCurrent

    if {![string compare * $what]} then {
      set what "pub msg dcc time"
    }
    foreach type $what {
      switch -exact -- $type {
        pub {
          set char [lindex $args 0]
          if {![string compare "" $char]} then {
            set char [commandChar pub]
          }
          $action pub m|m ${char}addhunt ${NamespaceCurrent}::pub:addhunt
          $action pub m|m ${char}delhunt ${NamespaceCurrent}::pub:delhunt
          $action pub m|m ${char}chhunt ${NamespaceCurrent}::pub:chhunt
          $action pub m|m ${char}listhunt ${NamespaceCurrent}::pub:listhunt
#          $action pub P|P ${char}sniff ${NamespaceCurrent}::pub:sniff
#          $action pub P|P ${char}hunt ${NamespaceCurrent}::pub:hunt
#          $action pub P|P ${char}endhunt ${NamespaceCurrent}::pub:endhunt
#          $action pub P|P ${char}caught ${NamespaceCurrent}::pub:caught
#          $action pub P|P ${char}eat ${NamespaceCurrent}::pub:eat
#          $action pub P|P ${char}bury ${NamespaceCurrent}::pub:bury
        }
        msg {
          $action msg m|m addhunt ${NamespaceCurrent}::msg:addhunt
          $action msg m|m delhunt ${NamespaceCurrent}::msg:delhunt
          $action msg m|m chhunt ${NamespaceCurrent}::msg:chhunt
          $action msg m|m listhunt ${NamespaceCurrent}::msg:listhunt
        }
        dcc {
          $action dcc m|m addhunt ${NamespaceCurrent}::dcc:addhunt
          $action dcc m|m delhunt ${NamespaceCurrent}::dcc:delhunt
          $action dcc m|m chhunt ${NamespaceCurrent}::dcc:chhunt
          $action dcc m|m listhunt ${NamespaceCurrent}::dcc:listhunt
        }
        time {
#          $action time -|- "* * * * *" ${NamespaceCurrent}::time:minutely
        }
      }
    }
    return
  }

} ;# wrpg-huntcmds

return
