###############################################################################
## This file is part of the Wolfpack module system
## Copyright (C) 1998-2001  Tothwolf <tothwolf@concentric.net>
## and is distributed according to the GNU general public license.
## For full details, read the top of wolfpack.tcl or the file called
## COPYING that was distributed with this code.
##
## $Id: wrpgnet.tcl,v 1.3 2001/06/01 05:38:49 tothwolf Exp $
##

# name: wrpgnet
# version: 0.2.1.1
# config: wrpgnet.conf
# description:
# requires: this_module_needs_to_be_converted

namespace eval wrpgnet {

  # Set namespace variables
  set NamespaceParent [namespace parent]
  set NamespaceCurrent [namespace current]

  #
  proc bot:wrpgmove {from cmd arg} {
    return 0
  }

  #
  proc dcc:n {hand idx arg} {
    putallbots "wrpgmove n $hand"
    return 0
  }

  #
  proc dcc:s {hand idx arg} {
    putallbots "wrpgmove s $hand"
    return 0
  }

  #
  proc dcc:e {hand idx arg} {
    putallbots "wrpgmove e $hand"
    return 0
  }

  #
  proc dcc:w {hand idx arg} {
    putallbots "wrpgmove w $hand"
    return 0
  }

  #
  proc dcc:ne {hand idx arg} {
    putallbots "wrpgmove ne $hand"
    return 0
  }

  #
  proc dcc:nw {hand idx arg} {
    putallbots "wrpgmove nw $hand"
    return 0
  }

  #
  proc dcc:se {hand idx arg} {
    putallbots "wrpgmove se $hand"
    return 0
  }

  #
  proc dcc:sw {hand idx arg} {
    putallbots "wrpgmove sw $hand"
    return 0
  }

  #
  proc dcc:u {hand idx arg} {
    putallbots "wrpgmove u $hand"
    return 0
  }

  #
  proc dcc:d {hand idx arg} {
    putallbots "wrpgmove d $hand"
    return 0
  }

  #
  proc dcc:home {hand idx arg} {
    putallbots "wrpgmove home $hand"
    return 0
  }

  ##
  ## Bind procs to commands and events
  ##
  ## Args:    action {bind|unbind}, what {type|*}, args {...}
  ## Returns: nothing
  ##
  proc BindTable {action what args} {
    variable NamespaceCurrent

    if {![string compare * $what]} then {
      set what "dcc bot"
    }
    foreach i $what {
      switch -exact -- $i {
        dcc {
          $action dcc P|P n ${NamespaceCurrent}::dcc:n
          $action dcc P|P s ${NamespaceCurrent}::dcc:s
          $action dcc P|P e ${NamespaceCurrent}::dcc:e
          $action dcc P|P w ${NamespaceCurrent}::dcc:w
          $action dcc P|P ne ${NamespaceCurrent}::dcc:ne
          $action dcc P|P nw ${NamespaceCurrent}::dcc:nw
          $action dcc P|P se ${NamespaceCurrent}::dcc:se
          $action dcc P|P sw ${NamespaceCurrent}::dcc:sw
          $action dcc P|P u ${NamespaceCurrent}::dcc:u
          $action dcc P|P d ${NamespaceCurrent}::dcc:d
          $action dcc P|P home ${NamespaceCurrent}::dcc:home
        }
        bot {
          $action bot -|- wrpgmove ${NamespaceCurrent}::bot:wrpgmove
        }
      }
    }
  }

} ;# namespace wrpgnet

return
